%{C_TEMPLATE}

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <SDL.h>

#ifdef GP2X
#include <unistd.h>
#endif

#ifdef GP32
#include <gp32_x.h>
#endif


static int pos_x = 0; static char x_dir = 0;
static int pos_y = 0; static char y_dir = 0;

void clearScreen(SDL_Surface * screen);
void drawSprite(SDL_Surface* imageSurface, SDL_Surface* screenSurface, int srcX, int srcY, int dstX, int dstY, int width, int height);

void Terminate(void)
{
    SDL_Quit();
    #ifdef GP2X
	chdir("/usr/gp2x");
	execl("/usr/gp2x/gp2xmenu", "/usr/gp2x/gp2xmenu", NULL);
    #endif
}


int main(int argc, char *argv[]) {
    atexit( Terminate );

    if (SDL_Init(SDL_INIT_VIDEO | SDL_INIT_JOYSTICK) < 0)
        return 1;
 
    SDL_Surface *screen;
    SDL_Surface *bitmap = NULL;
    int done = 0;

    screen = SDL_SetVideoMode(320, 240, 16, SDL_SWSURFACE);
    if (!screen) {
        fprintf(stderr, "Couldn't set video mode: %s\n", SDL_GetError());
        return 1;
    }

    SDL_JoystickOpen(0);
    SDL_ShowCursor(SDL_DISABLE);
    
    /* SKY-FIX: NO MORE SEGS FAULTS ;) */
    if((bitmap = SDL_LoadBMP("image.bmp")) == NULL){
      	    printf("Please copy some BMP image here and called it: image.bmp\n");
    	    exit(1);
    }

    while (!done) {
        SDL_Event event;

        SDL_PollEvent(&event);

        switch (event.type) {
	    case SDL_KEYDOWN:
            case SDL_JOYBUTTONDOWN:
            case SDL_QUIT:
                done = 1;
                break;
        }
        // bounce the logo around a bit
        if (x_dir == 0) {
            ++pos_x;
            if ( (pos_x + bitmap->w) >= screen->w )
                x_dir = 1;
        }
        else {
            --pos_x;
            if ( pos_x <= 0 )
                x_dir = 0;
        }
        if (y_dir == 0) {
            ++pos_y;
            if ( (pos_y + bitmap->h) >= screen->h )
                y_dir = 1;
        }
        else {
            --pos_y;
            if ( pos_y <= 0 )
                y_dir = 0;
        }

        clearScreen( screen );
        drawSprite(bitmap, screen, 0, 0, pos_x, pos_y, bitmap->w, bitmap->h);
        SDL_Flip(screen);
    }
    return 0;
}


void clearScreen(SDL_Surface * screen) {
    int i, j;
    for (i = 0; i < screen->h; i++) {
        for (j = 0; j < screen->w; j++) {
          *(((unsigned long*)screen->pixels) + i * (screen->pitch / 4) + j) = 0x000000;
        }
    }
}

void drawSprite(SDL_Surface* imageSurface, SDL_Surface* screenSurface, int srcX, int srcY, int dstX, int dstY, int width, int height) {
    SDL_Rect srcRect; 
    srcRect.x = srcX;
    srcRect.y = srcY;
    srcRect.w = width;
    srcRect.h = height;

    SDL_Rect dstRect;
    dstRect.x = dstX;
    dstRect.y = dstY;
    dstRect.w = width;
    dstRect.h = height;

    SDL_BlitSurface(imageSurface, &srcRect, screenSurface, &dstRect);
}
